routes/web.php
<?php

use App\Http\Controllers\Admin\CategoryProductController;
use App\Http\Controllers\Admin\DashboardController as AdminDashboardController;
use App\Http\Controllers\Admin\MaterialController;
use App\Http\Controllers\Admin\ProcessPlanController;
use App\Http\Controllers\Admin\ProductController;
use App\Http\Controllers\Admin\ProductTypeController;
use App\Http\Controllers\Admin\ProfileController;
use App\Http\Controllers\Admin\QualifierController;
use App\Http\Controllers\Admin\RoleController;
use App\Http\Controllers\ChartManageController;
use App\Http\Controllers\NotificationController;
use Illuminate\Support\Facades\Route;

Route::middleware('auth')->group(function () {
    Route::resource('/profile', ProfileController::class);
    Route::resource('/category', CategoryProductController::class);
    Route::resource('/product', ProductController::class);
    Route::resource('/rpp', ProcessPlanController::class);
});

Route::resource('/dashboard', AdminDashboardController::class);
Route::get('/get-profiles', [ProfileController::class, 'getProfiles'])->name('get-profiles');
Route::get('/get-rpps', [ProcessPlanController::class, 'getRpps'])->name('get-rpps');
Route::get('/get-all-products', [ProductController::class, 'getAllProducts'])->name('get-all-products');
Route::get('/get-warning-products', [ProductController::class, 'getWarningProducts'])->name('get-warning-products');
Route::get('/get-danger-products', [ProductController::class, 'getDangerProducts'])->name('get-danger-products');
Route::get('/get-products/{category}', [ProductController::class, 'getProductsByCategory'])->name('get-products-by-category');
Route::get('/get-categories', [CategoryProductController::class, 'getCategories'])->name('get-categories');
Route::get('/get-unused-products', [AdminDashboardController::class, 'getUnusedProducts'])->name('get-unused-products');
Route::get('/get-report-process-plan', [AdminDashboardController::class, 'getReportProcessPlan'])->name('get-report-process-plan');
Route::get('/get-qualifiers', [AdminDashboardController::class, 'getQualifiers'])->name('get-qualifiers');
Route::get('/material/search', [AdminDashboardController::class, 'search'])->name('material.search');
Route::get('/export/profiles', [ProfileController::class, 'exportProfiles'])->name('export.profiles');
Route::post('/import/profiles', [ProfileController::class, 'importProfiles'])->name('import.profiles');
Route::get('/export/products', [ProductController::class, 'exportProducts'])->name('export.products');
Route::post('/import/products', [ProductController::class, 'importProducts'])->name('import.products');
Route::get('/export/process-plans', [ProcessPlanController::class, 'exportProcessPlans'])->name('export.processplans');
Route::post('/import/process-plans', [ProcessPlanController::class, 'importProcessPlans'])->name('import.processplans');

Route::prefix('/json')->group(function () {
    Route::get('/get-rpps', [ProcessPlanController::class, 'getJsonRpps'])->name('get-json-rpps');
    Route::get('/get-products', [ProductController::class, 'getJsonProducts'])->name('get-json-products');
    Route::get('/get-products/{category}', [ProductController::class, 'getJsonProductsByCategory'])->name('get-json-products-by-category');
    Route::get('/get-product/{product}', [ProductController::class, 'getJsonProduct'])->name('get-json-product');
    Route::get('/get-product-types', [ProductTypeController::class, 'getJsonProductTypes'])->name('get-json-product-types');
    Route::get('/get-materials', [MaterialController::class, 'getJsonMaterials'])->name('get-json-materials');
    Route::get('/get-categories', [CategoryProductController::class, 'getJsonCategories'])->name('get-json-categories');
    Route::get('/get-category/{category}', [CategoryProductController::class, 'getJsonCategory'])->name('get-json-category');
    Route::get('/get-qualifiers', [QualifierController::class, 'getJsonQualifiers'])->name('get-json-qualifiers');
    Route::get('/get-roles', [RoleController::class, 'getJsonRoles'])->name('get-json-roles');
    Route::prefix('/chart')->group(function () {
        Route::get('/tinta', [ChartManageController::class, 'tintaMonthly'])->name('monthly.tinta.chart');
        Route::get('/rpp', [ChartManageController::class, 'rppYearly'])->name('yearly.rpp.chart');
        Route::get('/category', [ChartManageController::class, 'categoryOverall'])->name('category.overall.chart');
    });
});

Route::prefix('/notifications')->group(function () {
    Route::get('/', [NotificationController::class, 'index'])->name('notification.index');
    Route::get('/show/{id}', [NotificationController::class, 'show'])->name('notification.show');
    Route::post('/markAsRead', [NotificationController::class, 'markAsRead'])->name('notification.markAsRead');
});

Route::fallback(function () {
    return redirect()->route('dashboard.index');
});

require __DIR__ . '/auth.php';

app/Models/Product.php
<?php

namespace App\Models;

use App\Events\ProductQuantityLow;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Product extends Model
{
    use HasFactory, SoftDeletes;

    protected $fillable = [
        'material_id',
        'product_type_id',
        'qualifier_id',
        'category_product_id',
        'product_code',
        'name',
        'max_amount',
        'amount',
        'note',
    ];

    public function material(): BelongsTo
    {
        return $this->belongsTo(Material::class);
    }

    public function product_type(): BelongsTo
    {
        return $this->belongsTo(ProductType::class);
    }

    public function qualifier(): BelongsTo
    {
        return $this->belongsTo(Qualifier::class);
    }

    public function category_product(): BelongsTo
    {
        return $this->belongsTo(CategoryProduct::class);
    }

    public function outgoing_products(): HasMany
    {
        return $this->hasMany(OutgoingProducts::class);
    }

    public function incoming_products(): HasMany
    {
        return $this->hasMany(IncomingProducts::class);
    }
}

app/Models/ProductType.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Model;

class ProductType extends Model
{
    use HasFactory, SoftDeletes;

    protected $fillable = [
        'name',
        'desc',
    ];

    public function products()
    {
        return $this->hasMany(Product::class);
    }
}

app/Http/Controllers/Admin/ProductController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Events\DataAddedEvent;
use App\Events\DeletedDataEvent;
use App\Events\UpdateChartEvent;
use App\Events\UpdateDataEvent;
use App\Exports\ProductsExport;
use App\Http\Controllers\Controller;
use App\Http\Requests\ProductRequest;
use App\Imports\ProductsImport;
use App\Imports\RolesImport;
use App\Repositories\CategoryProductRepository;
use App\Repositories\ProductRepository;
use Illuminate\Contracts\View\View;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Yajra\DataTables\Facades\DataTables;
use Maatwebsite\Excel\Facades\Excel;

class ProductController extends Controller
{
    protected $productRepository;
    protected $categoryProductRepository;

    public function __construct(ProductRepository $productRepository, CategoryProductRepository $categoryProductRepository)
    {
        $this->productRepository = $productRepository;
        $this->categoryProductRepository = $categoryProductRepository;
    }

    public function index(): View
    {
        return view('product.index');
    }

    public function getProductsByCategory($category)
    {
        $products = $this->productRepository->getProductsByCategory($category);
        return DataTables::of($products)
            ->addColumn('material_name', function ($product) {
                return $product->material ? $product->material->name : 'N/A';
            })
            ->addColumn('product_type_name', function ($product) {
                return $product->product_type ? $product->product_type->name : 'N/A';
            })
            ->addColumn('qualifier_name', function ($product) {
                return $product->qualifier ? $product->qualifier->name : 'N/A';
            })
            ->addColumn('category_product_name', function ($product) {
                return $product->category_product ? $product->category_product->name : 'N/A';
            })
            ->addColumn('note', function ($product) {
                return $product->note ? $product->note : 'N/A';
            })
            ->addColumn('created_at', function ($product) {
                return $product->created_at->format('d-m-Y');
            })
            ->addColumn('updated_at', function ($product) {
                return $product->updated_at->format('d-m-Y');
            })
            ->addColumn('action', 'partials.button-table.product-action')
            ->rawColumns(['action'])
            ->make(true);
    }

    public function getAllProducts()
    {
        $products = $this->productRepository->all();
        return DataTables::of($products)
            ->addColumn('material_name', function ($product) {
                return $product->material ? $product->material->name : 'N/A';
            })
            ->addColumn('product_type_name', function ($product) {
                return $product->product_type ? $product->product_type->name : 'N/A';
            })
            ->addColumn('qualifier_name', function ($product) {
                return $product->qualifier ? $product->qualifier->name : 'N/A';
            })
            ->addColumn('category_product_name', function ($product) {
                return $product->category_product ? $product->category_product->name : 'N/A';
            })
            ->addColumn('note', function ($product) {
                return $product->note ? $product->note : 'N/A';
            })
            ->addColumn('created_at', function ($product) {
                return $product->created_at->format('d-m-Y');
            })
            ->addColumn('updated_at', function ($product) {
                return $product->updated_at->format('d-m-Y');
            })
            ->addColumn('action', 'partials.button-table.product-action')
            ->rawColumns(['action'])
            ->make(true);
    }

    public function getWarningProducts()
    {
        $products = $this->productRepository->getWarning();
        return DataTables::of($products)
            ->addColumn('material_name', function ($product) {
                return $product->material ? $product->material->name : 'N/A';
            })
            ->addColumn('product_type_name', function ($product) {
                return $product->product_type ? $product->product_type->name : 'N/A';
            })
            ->addColumn('qualifier_name', function ($product) {
                return $product->qualifier ? $product->qualifier->name : 'N/A';
            })
            ->addColumn('category_product_name', function ($product) {
                return $product->category_product ? $product->category_product->name : 'N/A';
            })
            ->addColumn('note', function ($product) {
                return $product->note ? $product->note : 'N/A';
            })
            ->addColumn('created_at', function ($product) {
                return $product->created_at->format('d-m-Y');
            })
            ->addColumn('updated_at', function ($product) {
                return $product->updated_at->format('d-m-Y');
            })
            ->addColumn('action', 'partials.button-table.product-action')
            ->rawColumns(['action'])
            ->make(true);
    }

    public function getDangerProducts()
    {
        $products = $this->productRepository->getDanger();
        return DataTables::of($products)
            ->addColumn('material_name', function ($product) {
                return $product->material ? $product->material->name : 'N/A';
            })
            ->addColumn('product_type_name', function ($product) {
                return $product->product_type ? $product->product_type->name : 'N/A';
            })
            ->addColumn('qualifier_name', function ($product) {
                return $product->qualifier ? $product->qualifier->name : 'N/A';
            })
            ->addColumn('category_product_name', function ($product) {
                return $product->category_product ? $product->category_product->name : 'N/A';
            })
            ->addColumn('note', function ($product) {
                return $product->note ? $product->note : 'N/A';
            })
            ->addColumn('created_at', function ($product) {
                return $product->created_at->format('d-m-Y');
            })
            ->addColumn('updated_at', function ($product) {
                return $product->updated_at->format('d-m-Y');
            })
            ->addColumn('action', 'partials.button-table.product-action')
            ->rawColumns(['action'])
            ->make(true);
    }

    public function create(): View
    {
        return view('product.create');
    }

    public function store(ProductRequest $request): RedirectResponse
    {
        $input = $request->validated();
        $product = $this->productRepository->create($input);

        $category = $this->categoryProductRepository->find($product->category_product_id);
        $count = $category->products->count();

        $data = [
            'id' => $product->category_product_id,
            'name' => $product->category_product->name,
            'qty' => $count,
            'context' => 'create',
        ];

        event(new DataAddedEvent($data, 'Product'));
        return redirect()->route('product.index')->with('success', 'Product created successfully');
    }

    public function edit($id): View
    {
        $product = $this->productRepository->find($id);
        return view('product.edit', compact('product'));
    }

    public function update($id, ProductRequest $request): RedirectResponse
    {
        $input = $request->validated();
        $product = $this->productRepository->find($id);
        $this->productRepository->update($id, $input);
        if ($request->category_product_id != $product->category_product_id) {
            $category_old = $this->categoryProductRepository->find($product->category_product_id);
            $category = $this->categoryProductRepository->find($request->category_product_id);
            $data = [
                'id' => $category->id,
                'id_old' => $product->category_product_id,
                'name_old' => $product->category_product->name,
                'name' => $category->name,
                'qty_old' => $category_old->products->count(),
                'qty' => $category->products->count(),
                'context' => 'update',
            ];
            event(new UpdateDataEvent($data, 'Product'));
        }
        return redirect()->route('product.index')->with('success', 'Product updated successfully');
    }

    public function destroy(string $id)
    {
        $product = $this->productRepository->find($id);
        $category = $this->categoryProductRepository->find($product->category_product_id);
        $this->productRepository->delete($id);

        $data = [
            'id' => $category->id,
            'name' => $category->name,
            'qty' => $category->products->count(),
            'context' => 'delete',
        ];

        event(new DeletedDataEvent($data, 'Product'));
        return redirect()->back()->with('success', 'Product berhasil dihapus');
    }

    public function getJsonProducts(Request $request): JsonResponse
    {
        $products = $this->productRepository->search($request->term);
        $formattedProducts = $products->map(function ($product) {
            return [
                'id' => $product->id,
                'text' => $product->name
            ];
        });
        return response()->json($formattedProducts);
    }

    public function getJsonProductsByCategory($category): JsonResponse
    {
        $products = $this->productRepository->getProductsByCategory($category);
        return response()->json($products);
    }

    public function getJsonProduct(string $id): JsonResponse
    {
        $product = $this->productRepository->find($id);
        return response()->json($product);
    }

resources/views/product/create.blade.php
@extends('adminlte::page')

@section('title', 'Tambah Barang')

@section('content_header')
    <h1>Tambah Barang</h1>
@stop

@section('content')
<div class="row">
    <div class="col-md-3">
        @if($message = Session::get('info'))
        <x-adminlte-alert theme="info" title="Info">
            {{ $message }}
        </x-adminlte-alert>
    </div>
    <div class="col-md-3">
        @elseif($message =  Session::get('success'))
        <x-adminlte-alert theme="success" title="Success">
            {{ $message }}
        </x-adminlte-alert>
    </div>
    <div class="col-md-3">
        @elseif($message =  Session::get('warning'))
        <x-adminlte-alert theme="warning" title="Warning">
            {{ $message }}
        </x-adminlte-alert>
    </div>
    <div class="col-md-3">
        @elseif($message =  Session::get('error'))
        <x-adminlte-alert theme="danger" title="Danger">
            {{ $message }}
        </x-adminlte-alert>
        @endif
    </div>
</div>
<div class="row">
    <div class="card col-md-12">
        <form action="{{ route('product.store') }}" method="post">
            @csrf
        <div class="card-body">
            <div class="row">
                <div class="col-md-6">
                    <label for="name">Nama</label>
                    <input type="text" class="form-control mb-3" name="name" label="Nama Barang" placeholder="Masukkan Nama Produk" required/>
                </div>
                <div class="col-md-6">
                    <label for="product_code">Kode Barang</label>
                    <input type="text" class="form-control mb-3" name="product_code" label="Kode Barang" id="product_code" placeholder="Masukkan Kode Barang" required/>
                </div>
            </div>
            <div class="row">
                <div class="col-md-4">
                    <label for="material_id">Material</label>
                    <select name="material_id" id="material_id" class="form-control mb-3" width="100%" required>
                        <option value="" selected disabled>Pilih Material</option>
                    </select>
                </div>
                <div class="col-md-4">
                    <label for="product_type_id">Tipe Barang</label>
                    <select name="product_type_id" id="product_type_id" class="form-control mb-3" width="100%" required>
                        <option value="" selected disabled>Pilih Tipe Barang</option>
                    </select>
                </div>
                <div class="col-md-4">
                    <label for="category_product_id">Kategori Barang</label>
                    <select name="category_product_id" id="category_product_id" class="form-control mb-3" width="100%" required>
                        <option value="" selected disabled>Pilih Kategori Barang</option>
                    </select>
                </div>
            </div><br>
            <div class="row">
                <div class="col-md-6">
                    <label for="note">Keterangan</label>
                    <textarea name="note" id="note" cols="30" rows="10" placeholder="Keterangan" class="form-control" style="height: 25%"></textarea>
                </div>
                <div class="col-md-2">
                    <label for="max_amount">Maksimal Stock</label>
                    <input type="number" class="form-control mb-3" name="max_amount" label="Max Stock" id="max_amount" placeholder="Masukkan Maximal Stock Produk" required/>
                </div>
                <div class="col-md-2">
                    <label for="max_amount">Stock Asli</label>
                    <input type="number" class="form-control mb-3" name="amount" id="amount" placeholder="Masukkan Stock Barang Asli" required/>
                </div>
                <div class="col-md-2">
                    <label for="qualifier_id">Satuan</label>
                    <select name="qualifier_id" id="qualifier_id" class="form-control mb-3 select2" required>
                        <option value="" selected disabled>Pilih Satuan Barang</option>
                    </select>
                </div>
            </div>
            <br>
            <div class="row justify-content-end">
                <div class="col-md-3">
                    <button class="form-control btn btn-success" type="submit">Save</button>
                </div>
            </div>
        </div>
    </form>
    </div>
</div>

@stop
    
    @section('css')
    @stop
    
    @section('js')
    <script src="{{ asset('/js/customSelect2.js') }}"></script>
    <script>
        const material = document.getElementById("material_id");
        const product_type_id = document.getElementById("product_type_id");
        const qualifier = document.getElementById("qualifier_id");
        const category_product = document.getElementById("category_product_id");
        const qualifier_url = '/json/get-qualifiers';
        const product_type_url = '/json/get-product-types';
        const material_url = '/json/get-materials';
        const category_product_url = '/json/get-categories';
        $(document).ready(function() {
            selectInput(qualifier, qualifier_url);
            selectInput(product_type_id, product_type_url);
            selectInput(material, material_url);
            selectInput(category_product, category_product_url);
        });
    </script>
@stop

resources/views/product/edit.blade.php
@extends('adminlte::page')

@section('title', 'Tambah Barang')

@section('content_header')
    <h1>Tambah Barang</h1>
@stop

@section('content')
<div class="row">
    <div class="col-md-3">
        @if($message = Session::get('info'))
        <x-adminlte-alert theme="info" title="Info">
            {{ $message }}
        </x-adminlte-alert>
    </div>
    <div class="col-md-3">
        @elseif($message =  Session::get('success'))
        <x-adminlte-alert theme="success" title="Success">
            {{ $message }}
        </x-adminlte-alert>
    </div>
    <div class="col-md-3">
        @elseif($message =  Session::get('warning'))
        <x-adminlte-alert theme="warning" title="Warning">
            {{ $message }}
        </x-adminlte-alert>
    </div>
    <div class="col-md-3">
        @elseif($message =  Session::get('error'))
        <x-adminlte-alert theme="danger" title="Danger">
            {{ $message }}
        </x-adminlte-alert>
        @endif
    </div>
</div>
<div class="row">
    <div class="card col-md-12">
        <form action="{{ route('product.update',['product'=>$product->id]) }}" method="post">
            @csrf
            @method('PUT')
        <div class="card-body">
            <div class="row">
                <div class="col-md-6">
                    <label for="name">Nama</label>
                    <input type="text" value="{{ $product->name }}" class="form-control mb-3" name="name" label="Nama Barang" placeholder="Masukkan Nama Produk" required/>
                </div>
                <div class="col-md-6">
                    <label for="product_code">Kode Barang</label>
                    <input type="text" class="form-control mb-3" value="{{ $product->product_code }}" name="product_code" label="Kode Barang" id="product_code" placeholder="Masukkan Kode Barang" required/>
                </div>
            </div>
            <div class="row">
                <div class="col-md-4">
                    <label for="material_id">Material</label>
                    <select name="material_id" id="material_id" class="form-control mb-3" width="100%" required>
                        @if($product->material)
                        <option value="{{ $product->material_id }}" selected>{{ $product->material->name }}</option>
                        @endif
                    </select>
                </div>
                <div class="col-md-4">
                    <label for="product_type_id">Tipe Barang</label>
                    <select name="product_type_id" id="product_type_id" class="form-control mb-3" width="100%" required>
                        @if($product->product_type)
                        <option value="{{ $product->product_type_id }}" selected>{{ $product->product_type->name }}</option>
                        @endif
                    </select>
                </div>
                <div class="col-md-4">
                    <label for="category_product_id">Kategori Barang</label>
                    <select name="category_product_id" id="category_product_id" class="form-control mb-3" width="100%" required>
                        @if($product->category_product)
                        <option value="{{ $product->category_product_id }}" selected>{{ $product->category_product->name }}</option>
                        @endif
                    </select>
                </div>
            </div><br>
            <div class="row">
                <div class="col-md-6">
                    <label for="note">Keterangan</label>
                    <textarea name="note" id="note" cols="30" rows="10" placeholder="Keterangan" class="form-control" style="height: 25%">{{ $product->note }}</textarea>
                </div>
                <div class="col-md-2">
                    <label for="max_amount">Maksimal Stock</label>
                    <input type="number" value="{{ $product->max_amount }}" class="form-control mb-3" name="max_amount" label="Max Stock" id="max_amount" placeholder="Masukkan Maximal Stock Produk" required/>
                </div>
                <div class="col-md-2">
                    <label for="max_amount">Stock Asli</label>
                    <input type="number" value="{{ $product->amount }}" class="form-control mb-3" name="amount" id="amount" placeholder="Masukkan Stock Barang Asli" required/>
                </div>
                <div class="col-md-2">
                    <label for="qualifier_id">Satuan</label>
                    <select name="qualifier_id" id="qualifier_id" class="form-control mb-3 select2" required>
                        @if($product->qualifier)
                        <option value="{{ $product->qualifier_id }}" selected>{{ $product->qualifier->name }}</option>
                        @endif
                    </select>
                </div>
            </div>
            <br>
            <div class="row justify-content-end">
                <div class="col-md-3">
                    <button class="form-control btn btn-success" type="submit">Save</button>
                </div>
            </div>
        </div>
    </form>
    </div>
</div>

@stop
    
    @section('css')
    @stop
    
    @section('js')
    <script src="{{ asset('/js/customSelect2.js') }}"></script>
    <script>
        const material = document.getElementById("material_id");
        const product_type_id = document.getElementById("product_type_id");
        const qualifier = document.getElementById("qualifier_id");
        const category_product = document.getElementById("category_product_id");
        const qualifier_url = '/json/get-qualifiers';
        const product_type_url = '/json/get-product-types';
        const material_url = '/json/get-materials';
        const category_product_url = '/json/get-categories';
        $(document).ready(function() {
            selectInput(qualifier, qualifier_url);
            selectInput(product_type_id, product_type_url);
            selectInput(material, material_url);
            selectInput(category_product, category_product_url);
        });
    </script>
@stop